#include <HT32F125x.h>                    // 

/* Fijarse en Project -> Options -> C/C++ Compiler -> Preprocessor
los paths para agregar el CMSIS y que el IAR lo incluya 
est en $TOOLKIT_DIR$/CMSIS porque yo (SRC) lo puse ahi */

#include <math.h>
#define m_PI 3.14159265358979323846264338327
#include <stdio.h>

#include "HD61202.h"


#include "pics.h"
#include "icon.h"


volatile unsigned long SysTickCnt;      // SysTick Counter

// SysTick Setup
void SysTick_Setup (void)
{
  SysTick->LOAD = 72000 - 1;            // 1ms: 72000 ticks @ 72MHz
  SysTick->CTRL = 0x0007;               // Enable Counter and Tick Interrupt
}

// SysTick Interrupt Handler (tick each 1ms)
void SysTick_Handler (void)
{
  SysTickCnt++;
}


// Delay Function
void Delay (unsigned long tick)
{
unsigned long systickcnt;

  systickcnt = SysTickCnt;
  while ((SysTickCnt - systickcnt) < tick);
}
#define MsDelay Delay

float rand(void)
{
static unsigned long idum;
unsigned long itemp;
const static unsigned long jflone = 0x3f800000;
const static unsigned long jflmsk = 0x007fffff;

idum = 1664525L*idum + 1013904223L;
itemp = jflone | (jflmsk & idum);
return((*(float *)&itemp)-1.0);
}


/* MAIN PROGRAM */

main()
{
int i;
extern const uint8_t Cika[],Holtek[];
char numero[6];
float num,prom,vcc,sum;


	SysTick_Setup();
	LCD_init();

        while(1){

		LCD_clear();
		MsDelay ( 3000 );						// wait 3 secs
		LCD_fill(0xFF);						// black fill
		MsDelay ( 3000 );						// wait 3 secs
		LCD_clear();

		for(i=0;i<128;i++)
			LCD_plot(i,32); 					// x axis
		for(i=0;i<64;i++)
			LCD_plot(64,i); 					// y axis
		for(i=-64;i<63;i++)
			LCD_plot(64+i,32-(int)(32*(cosf(i*m_PI/64)))); // plot sin(x); 0,0 is at top left
		LCD_printat(0,0,"cos(x)");
		MsDelay ( 3000 );						// wait 3 secs
		LCD_dump((uint8_t *)Cika);	
		MsDelay ( 3000 );						// wait 3 secs
		LCD_dump((uint8_t *)Holtek);	
		MsDelay ( 3000 );						// wait 3 secs
		LCD_dump((uint8_t *)ARM);	
		MsDelay ( 3000 );						// wait 3 secs

		LCD_clear();
		LCD_print6at(0,0,"Texto en 6x8, 20 cpl");
		LCD_print8at(2,0,0,"Texto 8x8, 16cpl");
		LCD_print8at(4,0,'B',"Texto 8x16,16cpl");
		MsDelay (5000);
		LCD_invert(4,0,20*6);
		LCD_invert(0,2,16*8);
		LCD_invert(0,4,16*8);
		LCD_invert(0,5,16*8);
		MsDelay (5000);
		LCD_clear();
		LCD_print6at(1,0,"El texto en 6x8 es  ideal para mostrar  dialogos cortos");
		LCD_rectangle(0,0,120,40);
		MsDelay (5000);
		LCD_clear();
		LCD_print8at(1,0,0,"El texto en 8x8 resalta valores de variables:");
		LCD_print6at(7,0,"Corriente:        mA");
		LCD_print8at(7,9,0,"12,3");
		MsDelay (5000);
		LCD_clear();
		LCD_print8at(1,0,'B',"El formato 8x16 resulta ideal ennumeros");
		MsDelay (5000);
		LCD_clear();
		LCD_print6at(0,4,"Caudalimetro");
		LCD_line(26,8,98,8);
		LCD_print6at(2,0,"Caudal:        m3/hr");
		LCD_print6at(5,0," Qprom:        m3/hr");
		LCD_print6at(7,0,"  Alim:        V");
		num=110.0;
		vcc=5.0;
		sum=0;
		for(i=1;i<41;i++) {
			num+=(rand()-0.5)/10;
			sum+=num;
			prom=sum/i;
			sprintf(numero,"%d.%d",(int)num,((int)(10.0*num))%10);
			LCD_print8at(2,6,'B',numero);
			sprintf(numero,"%d.%d",(int)prom,((int)(10.0*prom))%10);
			LCD_print8at(5,6,0,numero);
			vcc+=(rand()-0.5)/100;
			sprintf(numero,"%d.%02d",(int)vcc,((int)(100.0*vcc))%100);
			LCD_print8at(7,7,0,numero);
			MsDelay (500);
		}
		LCD_clear();
		i=10;
		while(i--){
			LCD_icon((uint8_t *)icon,(128-35)/2,2,35,4);
			MsDelay(500);
			LCD_area(0,(128-35)/2,2,35,4);
			MsDelay(500);
		}
				
	}
}
